
/* gss_glue.c */

#include	<strings.h>
#include	<syslog.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>

#include        <globus_gass_server_ez.h>
#include        <globus_gram_client.h>
#include        <globus_gram_protocol.h>

#include	"glogin.h"
//#ifdef DEBUG
#include	"channel.h"
//#endif

extern int do_remote;
extern int do_staging;
extern int do_exec;
extern int do_encrypt;

extern char secret[16];
extern u_int opt_port;
extern int do_addr;
extern char *opt_addr;
extern char *cert_subject;
extern struct in_addr self_addr;

extern int enc_mode;

#ifndef I2G
static globus_mutex_t mutex;
static globus_cond_t cond;

static int error_code=0;

static void client_cb(void *u,char *jc,int state,int err) {
	debug(">client_cb state=%d\n",state);
	//fprintf(stderr,">client_cb jc=%s state=%d\n",jc,state);
	*(int *)u=state;
	error_code=err;
	globus_cond_signal(&cond);
}
#endif

#if 0
void xdump(char *hdr, void *arg, int len) {
u_char *cp=(u_char *)arg;
char *s,*buf;
int i;
        if ((buf=alloca(strlen(hdr)+3*len+16))==NULL)
                return;
        s=buf;
        s+=sprintf(s,"%s:",hdr);
        for(i=0;i<len;i++)
                s+=sprintf(s," %.2x",cp[i]);
        sprintf(s,"\n");
        if (do_remote)
                logger(LOG_AUTH,buf);
        else fprintf(stderr,buf);
}
#endif

#ifndef I2G
static gss_cred_id_t credh=GSS_C_NO_CREDENTIAL;
#endif

static gss_name_t client_name=GSS_C_NO_NAME;
static gss_OID *actual_mech_type=NULL;
static gss_buffer_desc name_buffer;
static gss_buffer_desc ibuf_desc,obuf_desc;
static OM_uint32 ret_flags;
static OM_uint32 maj,min;

/*public*/ gss_ctx_id_t ctxh=GSS_C_NO_CONTEXT;

void gss_set_encryption(int mode) {
	enc_mode=mode;
	write_token=enc_mode?write_token_enc:write_token_clear;
	read_token=enc_mode?read_token_enc:read_token_clear;
}

void gsserror(OM_uint32 cmaj,OM_uint32 cmin) {
gss_buffer_desc msg=GSS_C_EMPTY_BUFFER;
OM_uint32 i;

	i=0;
	do {
		if (gss_display_status(&min,cmaj,
			GSS_C_GSS_CODE,
			GSS_C_NO_OID,
			&i,&msg)==GSS_S_COMPLETE)

			if (msg.length) {
				if (do_remote) logger(LOG_ERR,"%s\n",(char *)msg.value);
				else fprintf(stderr,"%s\n",(char *)msg.value);
			}
		free(msg.value);
	} while(i);
	i=0;
	do {
		if (gss_display_status(&min,cmin,
			GSS_C_MECH_CODE,
			GSS_C_NO_OID,
			&i,&msg)==GSS_S_COMPLETE)

			if (msg.length) {
				if (do_remote) logger(LOG_ERR,"%s\n",(char *)msg.value);
				else fprintf(stderr,"%s\n",(char *)msg.value);
			}
		free(msg.value);
	} while(i);
}

#ifndef I2G
#ifndef WSGRAM
/*
 * modifies "opt_port" as a side-effect
 * sets global variables:
 * - eflag
 * - raddr
 * - g_is.secret
 */

int gssexec(char *host,char *exec,u_short port,char *rsl,
	int argc,char *argv[]) {
globus_gass_transfer_listener_t listener=GLOBUS_NULL;
#if 0
globus_gass_transfer_listenerattr_t attr;
char *scheme;
#endif
char buf[4096];
char dir_str[24];
initseq_t sq;
int p[2];
char *su,*jc,*cc,*args,*cp;
char version[32];
int jobstate;
int rc,fd;
int i;

#if 0
	printf("> gssexec(host=%s exec=%s port=%hd)\n",
		host,exec,port);
	printf("  argc=%d\n",argc);
	for(i=0;i<argc;i++)
		printf("  arg%d=%s\n",i,argv[i]);
#endif

	globus_module_activate(GLOBUS_GASS_SERVER_EZ_MODULE);
	// printf("  module activated\n");

	if ((maj=gss_acquire_cred(&min,NULL,GSS_C_INDEFINITE,
                GSS_C_NO_OID_SET,
                GSS_C_BOTH,
                &credh,
                NULL,
                NULL))!=GSS_S_COMPLETE) {

		gsserror(maj,min);
		exit(-1);
	 }

	// scheme="http";
	// globus_gass_transfer_listenerattr_init(&attr,scheme);
	//globus_gass_transfer_listenerattr_set_port(&attr,1234);

	globus_gass_server_ez_init(&listener,
		NULL,NULL,NULL,
		// &attr,scheme,NULL,
		GLOBUS_GASS_SERVER_EZ_LINE_BUFFER|
		GLOBUS_GASS_SERVER_EZ_READ_ENABLE|
		GLOBUS_GASS_SERVER_EZ_WRITE_ENABLE|
		GLOBUS_GASS_SERVER_EZ_STDOUT_ENABLE|
		GLOBUS_GASS_SERVER_EZ_STDERR_ENABLE,
		//GLOBUS_GASS_SERVER_EZ_CLIENT_SHUTDOWN_ENABLE,
		NULL);

	su=globus_gass_transfer_listener_get_base_url(listener);
	//su="http://clio.gup.uni-linz.ac.at:8080";
	//printf("gass_server=%s\n",su);
	cc=NULL;
	rc=globus_gram_client_callback_allow(client_cb,
		&jobstate,
		&cc);
	// printf("rc==%d\n",rc);
	//fprintf(stderr,"globus_gram_client_callback_allow: cc=%s\n",cc);
	if (cc==NULL) die("no callback contact");

	/* construct command line for remote glogin */

	argc--;	// last arg is hostname, dont copy that.
	rc=0;
	for(i=1;i<argc;i++)
		rc+=strlen(argv[i]);
	rc+=argc+3+2+22; /* +3 "-r" +2 escaping "  +22 chars for -p port:addr */
	if ((args=(char *)alloca(rc))==NULL)
		die("out of memory");

	cp=args;

	memcpy(cp,"-p ",3);
	cp+=3;
	cp+=sprintf(cp,"%d:",opt_port);
	cp+=sprintf(cp,"%s ",inet_ntoa(self_addr));

	/* we need -r to tell glogin that it executes remotely */
	memcpy(cp,"-r",2);
	cp+=2;
	for(i=1;i<argc;i++) {
		/* ignore these options */
		if (strcmp(argv[i],"-g")==0)	/* staging: ignore */
			continue;
		if (strcmp(argv[i],"-q")==0) {	/* queue: ignore */
			i++;
			continue;
		}
		if (strcmp(argv[i],"-s")==0) {	/* extra rsl: ignore */
			i++;
			continue;
		}
		if (strcmp(argv[i],"-p")==0) {	/* port: ignore (handled above) */
			i++;
			continue;
		}
		*cp++=' ';
		if (strcmp(argv[i-1],"-c")==0)	/* quote -c arg */
			*cp++='\'';
		rc=strlen(argv[i]);
		memcpy(cp,argv[i],rc);
		cp+=rc;
		if (strcmp(argv[i-1],"-c")==0)
			*cp++='\'';
	}
	*cp=0;
	//fprintf(stderr,"args=%s\n",args);
#ifdef CROSSGRID
	strcpy(dir_str,"/opt/cg");
#else
	strcpy(dir_str,"$(GLOBUS_LOCATION)");
#endif

	/* build rsl */
	strcpy(buf,"&(executable=");
	i=sizeof(buf)-strlen(buf)-1;
	if (do_staging) {	/* stage executable */
		strncat(buf,su,i);
		i=sizeof(buf)-strlen(buf)-1;
		if (!do_exec) {
			strncat(buf,"/proc/self/exe",i);
			i=sizeof(buf)-strlen(buf)-1;
		}
	}
	if (do_exec || (!do_exec && !do_staging)) {	/* -l (location) parameter specified */
		if (exec[0]!='/') { /* relative filename */
			strncat(buf,"$(GLOBUS_LOCATION)",i);
			i=sizeof(buf)-strlen(buf)-1;
			strncat(buf,"/",i);
			i--;
		}
		strncat(buf,exec,i);
	}

	i=sizeof(buf)-strlen(buf)-1;
	snprintf(buf+strlen(buf),i,")%s(arguments=%s)(stdout=%s # /dev/stdout)(stderr=%s # /dev/stderr)",
		rsl?rsl:"",
		args,su,su);
	//fprintf(stderr,"rsl=%s\n",buf);
	debug("rsl=%s\n",buf);

	/*
	 * create that pipe thing before submitting the job
	 */
	// printf("setup pipe1\n");
	/* IPC as in "IntraProcessCommuncation,
	 * an "autistic" process ;-)
	 */
	if (pipe(p)==-1)
		die("pipe");
	fd=dup(1);	/* save stdout* */
	dup2(p[1],1);	/* we need the output from gass_server */
#if 1
	if (index(host,'/')) cp=host;
	else {
		/*jobmanager-fork*/
		/*123456789012345*/
		cp=alloca(strlen(host)+17);
		strcpy(cp,host);
		strcat(cp,"/jobmanager-fork");
	}
	rc=globus_gram_client_job_request(cp,buf,
#else
	rc=globus_gram_client_job_request(host,buf,
#endif
		GLOBUS_GRAM_PROTOCOL_JOB_STATE_ALL,
		cc,&jc);
	//fprintf(stderr,"job has been requested, job contact=%s\n",jc);
	debug("job has been requested, jc=%s\n",jc);
	if (jc==NULL) {
                fprintf(stderr,"GRAM Job submission failed because %s (error code %d)\n",
                        globus_gram_protocol_error_string(rc),
                        rc);
		exit(-1);
	}

	/* wait as long as the job is active
	 * due to the "gass-cache-flush" mechanism, the
	 * job (glogin' in dieter's paper) will _always_
	 * terminate.
	 */

	jobstate=0;
	do {
		globus_cond_wait(&cond, &mutex);
		debug("jobstate=%d\n",jobstate);
	} while(!(jobstate&(GLOBUS_GRAM_PROTOCOL_JOB_STATE_DONE|GLOBUS_GRAM_PROTOCOL_JOB_STATE_FAILED)));

	if (jobstate&GLOBUS_GRAM_PROTOCOL_JOB_STATE_FAILED) {
		fprintf(stderr,"error: job request (globusrun) failed, error code %d\n",error_code);
		exit(-1);
	}
	debug("about to read port\n");
	/* the initial sequence ... */
	rc=read(p[0],&sq,sizeof(sq));
	if (rc==28)
		die("incompatible versions");	// length of initseq <= v0.97
	if (rc!=sizeof(sq))
		die("read");
	if (sq.sq_vers_len>=sizeof(version))
		die("strange version");
	i=sq.sq_vers_len+1;
	if (read(p[0],version,i)!=i)
		die("read");
#ifdef DEBUG
	version[i]=0;
	debug("version=%s\n",version);
#endif
        if (strcmp(version,GSH_PROTOCOL))
                die("wrong protocol version");

	dup2(fd,1);	/* restore fd */
	close(fd);

	opt_port=ntohs(sq.sq_port);
	debug("got port=%d\n",opt_port);

	/* ip addr of other end */
	r_addr=*(struct in_addr *)&sq.sq_inaddr;

	/* endian signature */
	eflag=sq.sq_beef!=0xfeedbeef;

	/* and now the secret key */
	memcpy(g_ic.secret,sq.sq_secret,16);

	close(p[0]);
	close(p[1]);
	// printf("opt_port=%d\n",opt_port);

	globus_gass_server_ez_shutdown(listener);
	globus_module_deactivate(GLOBUS_GASS_SERVER_EZ_MODULE);

	//debug("< gssexec\n");
	return 0;
}
#endif
#endif

static OM_uint32 check_context(OM_uint32 *min,gss_ctx_id_t ctx,gss_name_t client_name) {
gss_cred_id_t credh;
int i,j;

        /*
         * get default credential, either an active proxy in /tmp
         *  or the user-certs in ~/.globus
         */
        if (GSS_ERROR(maj=gss_acquire_cred(min,
                GSS_C_NO_NAME,GSS_C_INDEFINITE,GSS_C_NO_OID_SET,GSS_C_BOTH,
                &credh,NULL,NULL)))
                return maj;

        gss_name_t cred_name;
        if (GSS_ERROR(maj=gss_inquire_cred(min,credh,&cred_name,
                NULL,NULL,NULL)))
		return maj;
	if (GSS_ERROR(maj=gss_release_cred(min,&credh)))
                return maj;
	/*
	 * check the given name, if we have one
	 */
	if (client_name) {
#if 0
		gss_buffer_desc name_buffer;
		gss_display_name(min,cred_name,&name_buffer,NULL);
		logger(LOG_AUTH,"check_context: cred_name=%s\n",
			(char *)name_buffer.value);
		gss_release_buffer(min,&name_buffer);
#endif
        	if (GSS_ERROR(maj=gss_compare_name(min,cred_name,client_name,&i)))
			return maj;
		if (i==0) {
			logger(LOG_AUTH,"security context from different user\n");
			exit(-1);
		}
		goto release_cred_name;
	}

	gss_name_t source_name;
	gss_name_t target_name;
        /*
         * ... else get security context subject and issuer
         */
        if (GSS_ERROR(maj=gss_inquire_context(min,
                ctxh,
                &source_name,
                &target_name,
                NULL,NULL,
                NULL,NULL,NULL)))
                return maj;
#if 0
	gss_buffer_desc name_buffer;
	gss_display_name(min,source_name,&name_buffer,NULL);
	fprintf(stderr,"source: %s\n",(char *)name_buffer.value);
	gss_release_buffer(min,&name_buffer);
	gss_display_name(min,target_name,&name_buffer,NULL);
	fprintf(stderr,"target: %s\n",(char *)name_buffer.value);
	gss_release_buffer(min,&name_buffer);
	gss_display_name(min,cred_name,&name_buffer,NULL);
	fprintf(stderr,"cred:   %s\n",(char *)name_buffer.value);
	gss_release_buffer(min,&name_buffer);
#endif
        /*
         * name check: the credential, source and target DN have
         *             all to be the same
         */
        if (GSS_ERROR(maj=gss_compare_name(min,cred_name,target_name,&i)))
		return maj;
        if (GSS_ERROR(maj=gss_compare_name(min,cred_name,source_name,&j)))
		return maj;
        if (i==0 || j==0) {
                fprintf(stderr,"security context from different user\n");
                exit(-1);
        }

        gss_release_name(min,&source_name);
        gss_release_name(min,&target_name);
release_cred_name:
        gss_release_name(min,&cred_name);
	gss_release_cred(min,&credh);

	return GSS_S_COMPLETE;
}

/*
 * note: even though we specify the "GSS_C_DELEG_FLAG",
 *       it does not seem to be possible to use the
 *       created certificate on the target system
 *       for further globus-actions on other, 3rd
 *       systems. therefore, we handle delegation of
 *       proxy ourselves with the TMSG_PROXY protocol
 *       option.
 */
// #define CON_FLAGS	(GSS_C_DELEG_FLAG|GSS_C_MUTUAL_FLAG|GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG)
//#define CON_FLAGS	(GSS_C_MUTUAL_FLAG|GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG)
#define CON_FLAGS	(GSS_C_MUTUAL_FLAG|GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG|GSS_C_INTEG_FLAG)

int gssinit(int s) {

	debug("> gssinit\n");
	ibuf_desc.value=alloca(4096);
	for(;;) {
		maj=gss_init_sec_context(&min,
			GSS_C_NO_CREDENTIAL,
			// credh,
			&ctxh,
			GSS_C_NO_NAME,
			GSS_C_NO_OID,
			//GSS_C_DELEG_FLAG|GSS_C_MUTUAL_FLAG|GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG,
			//GSS_C_MUTUAL_FLAG|GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG,
			//GSS_C_REPLAY_FLAG|GSS_C_SEQUENCE_FLAG|GSS_C_CONF_FLAG,
			CON_FLAGS,
			0,
			GSS_C_NO_CHANNEL_BINDINGS,
			&ibuf_desc,
			actual_mech_type,
			&obuf_desc,
			&ret_flags,
			NULL);
		// xdump("  init_sec msg",obuf_desc.value,obuf_desc.length);
		if (obuf_desc.length) {
			if (write_token_enc(s,obuf_desc.value,obuf_desc.length)==-1)
				die("write_token_enc");
			gss_release_buffer(&min,&obuf_desc);
		}
		if (GSS_ERROR(maj))
			goto error_situation;
		if ((maj&GSS_S_CONTINUE_NEEDED)==0)
			break;
		/* set max.length - will be reduced by read_token */
		// if (read_token_enc(s,&ibuf_desc.value,(uint32_t *)&ibuf_desc.length,NULL)==-1)
		if ((ibuf_desc.length=read_token_unbuffered(s,ibuf_desc.value,4096))==-1)
			die("read_token");
	}

	maj=check_context(&min,ctxh,NULL);
	if (GSS_ERROR(maj))
		goto error_situation;

	debug("< gssinit\n");
	return 0;

error_situation:
	fprintf(stderr,"gssinit: failed to initialize security context\n");
	gsserror(maj,min);
	exit(-1);
}

int gssaccept(int s) {

	debug("> gssaccept\n");
	debug("x509_up=%s\n",getenv("X509_USER_PROXY"));
	//if (getenv("X509_USER_PROXY")==NULL)
		//putenv("X509_USER_PROXY=/tmp/x509_up");

	ibuf_desc.value=alloca(4096);
	ret_flags=0;
	for(;;) {
		if ((ibuf_desc.length=read_token_unbuffered(s,ibuf_desc.value,4096))==-1)
			die("read_token");
		debug("  gssaccept: read_token returns len=%d\n",ibuf_desc.length);
		maj=gss_accept_sec_context(&min,
			&ctxh,
			GSS_C_NO_CREDENTIAL,
			&ibuf_desc,
			GSS_C_NO_CHANNEL_BINDINGS,
			&client_name,
			NULL,
			&obuf_desc,
			&ret_flags,
			NULL,
			NULL);
		/*
		 * uh oh! gss_accept_sec_context deletes
		 * our env.var X509_USER_PROXY. why is this?
		 */
		debug("x509_up=%s\n",getenv("X509_USER_PROXY"));
		if (obuf_desc.length) {
			if (write_token_enc(s,obuf_desc.value,obuf_desc.length)==-1)
				die("write_token");
			gss_release_buffer(&min,&obuf_desc);
		}
		if (GSS_ERROR(maj)) {
			//logger(LOG_AUTH,"gssaccept: failed to initialize security context\n");
			logger(LOG_ERR,"gssaccept: failed to initialize security context\n");
			gsserror(maj,min);
			die("gssaccept");
		}
		if ((maj&GSS_S_CONTINUE_NEEDED)==0)
			break;
	}

	maj=check_context(&min,ctxh,client_name);
	if (GSS_ERROR(maj)) {
		gsserror(maj,min);
		die("gssaccept");
	}

	gss_display_name(&min,client_name,&name_buffer,NULL);
	logger(LOG_INFO,"login %s\n",(char *)name_buffer.value);
	cert_subject=strdup((char *)name_buffer.value);
	gss_release_name(&min,&client_name);
	gss_release_buffer(&min,&name_buffer);
	/* paranoia: make sure anon is clear */
	if ((ret_flags&(CON_FLAGS|GSS_C_ANON_FLAG))!=CON_FLAGS)
		die("insufficient connection security");
	debug("< gssaccept\n");
	return 0;
}

int gsswrite(int fd,gss_buffer_desc *ibuf) {
gss_buffer_desc obuf;
OM_uint32 maj,min;
int i;

	debug("> gsswrite ibuf->length=%d\n",ibuf->length);
	if (enc_mode) {
		maj=gss_wrap(&min,ctxh,1,GSS_C_QOP_DEFAULT,
			ibuf,&i,&obuf);
		if (GSS_ERROR(maj)) {
			gsserror(maj,min);
			die("gss_wrap");
		}
	}
	else {
		obuf.value=ibuf->value;
		obuf.length=ibuf->length;
	}
#if 0
	for(i=0;i<obuf.length;i++) {
	u_char ch;
		ch=((u_char *)obuf.value)[i];
		debug("%.2x %c\n",ch,isprint(ch)?ch:'.');
	}
#endif
	if ((*write_token)(fd,obuf.value,obuf.length)==-1)
		die("write_token");
	if (enc_mode)
		gss_release_buffer(&min,&obuf);
	return obuf.length;
}

#include	<sys/utsname.h>

int gssread(int fd,gss_buffer_desc *obuf,int *data_left) {
gss_buffer_desc ibuf;
OM_uint32 maj,min;

	// debug("> gssread\n");
	if ((*read_token)(fd,&ibuf.value,&ibuf.length,data_left)==-1)
		die("read_token");

	if (enc_mode) {
		// debug("unwrapping...\n");
		//fprintf(stderr,"ibuf.length=%d\n",ibuf.length);
		maj=gss_unwrap(&min,ctxh,&ibuf,obuf,NULL,NULL);
		//fprintf(stderr,"obuf->length=%d\n",obuf->length);

		// if (ibuf.length)
		// 	free(ibuf.value);
		if (GSS_ERROR(maj)) {
		struct utsname uts;
		uname(&uts);
			fprintf(stderr,"gsserror: mag=%x min=%x\n",maj,min);
			gsserror(maj,min);
			fprintf(stderr,"ibuf.length=%d\n",ibuf.length);
			fprintf(stderr,"obuf->length=%d\n",obuf->length);
			fprintf(stderr,"obuf->length=%d\n",obuf->length);
			fprintf(stderr,"node=%s pid=%d\n",uts.nodename,getpid());
			fflush(stderr);
pause();
			abort();
			die("gss_unwrap");
		}
	}
	else {
		obuf->value=ibuf.value;
		obuf->length=ibuf.length;
	}
	 debug("< gssread data_left=%d\n",data_left?*data_left:-1);
	return obuf->length;
}
