#ifdef WSGRAM
/*
 * Sat Nov 25 14:11:59 CET 2006 herp - Herbert Rosmanith
 *
 * exec a globusrun with webservices (GT4)
 *
 * exported function:
 *
 * int gssexec(char *host,char *exec,u_short port,char *rsl,
 * 	int argc,char *argv[]) {
 *
 * this file is part of glogin, go to
 *     http://www.gup.uni-linz.ac.at/glogin
 *
 */

#include	<sys/types.h>
#include	<arpa/inet.h>

#include	<globus_common.h>
#include	<globus_ftp_client.h>
#include	<globus_gsi_cert_utils.h>
#include	<globus_gsi_credential.h>
#include	<globus_notification_consumer.h>
#include	<globus_delegation_client_util.h>

#include        <DelegationService_client.h>
#include        <ManagedJobService_client.h>
#include        <SubscriptionManagerService_client.h>
#include        <ManagedJobFactoryService_client.h>
#include        <ManagedExecutableJobService_client.h>

#include        <wsgram_StateChangeNotificationMessageWrapperType.h>

#include	"glogin.h"

#define BUF_SIZE        4096

extern int do_staging;
extern int do_exec;

extern u_int opt_port;
extern struct in_addr self_addr;

static xsd_QName factory_type_ResourceID_qname = {
    "http://www.globus.org/namespaces/2004/10/gram/job",
    "ResourceID"
};

typedef struct {
	globus_mutex_t			lock;
	globus_cond_t			cond;

	globus_soap_message_attr_t	msg_attr;

        globus_ftp_client_handle_t          ftp_handle;
        globus_ftp_client_operationattr_t   ftp_attr;
        xsd_anyURI                          stdout_url;

	initseq_t sq;
	char version[32];
	int rc;

	ManagedJobService_client_handle_t	job_handle;
	wsa_EndpointReferenceType		*job_epr;

	int	done;

} monitor_t;

static void
read_done_cb(
    void *                              user_arg,
    globus_ftp_client_handle_t *        handle,
    globus_object_t *                   error,
    globus_byte_t *                     buffer,
    globus_size_t                       length,
    globus_off_t                        offset,
    globus_bool_t                       eof)
{
monitor_t *mon=(monitor_t *)user_arg;
int i;

	memcpy(&mon->sq,buffer,sizeof(initseq_t));
	i=length-sizeof(initseq_t);
	if (i>sizeof(mon->version))
		i=sizeof(mon->version);
	memcpy(&mon->version,buffer+sizeof(initseq_t),i);
	mon->rc=length;
}

static void delete_done_cb(
        void *                          user_arg,
        globus_ftp_client_handle_t *    handle,
        globus_object_t *               error)
{ 
        ((monitor_t *)user_arg)->done=-1;       // terminate job
}   

static void get_done_cb(
	void *                              user_arg,
    	globus_ftp_client_handle_t *        handle,
    	globus_object_t *                   error)
{
monitor_t *mon=(monitor_t *)user_arg;
globus_result_t ret;

	ret = globus_ftp_client_delete(
		&mon->ftp_handle,
		mon->stdout_url,
		&mon->ftp_attr,
		delete_done_cb,user_arg);
	if (ret) die("globus_ftp_client_delete");
}   
 
static void ftp_get(monitor_t *mon) {
globus_byte_t *buffer;
globus_result_t ret;

        if ((buffer=(globus_byte_t *)malloc(BUF_SIZE))==NULL)
		die("malloc");

        ret=globus_ftp_client_partial_get(
                &mon->ftp_handle,
                mon->stdout_url,
                &mon->ftp_attr,
                NULL,
                //mon->position,mon->position+BUF_SIZE,
		0,BUF_SIZE,
                get_done_cb,mon);
        if (ret) die("globus_ftp_client_partial_get");

        ret=globus_ftp_client_register_read(
                &mon->ftp_handle,
                buffer,
                BUF_SIZE,
                read_done_cb,
                mon);
        if (ret) die("globus_ftp_client_partial_get");
}

static void get_stdout_url(monitor_t *mon) {
ManagedExecutableJobService_client_handle_t handle;
ManagedExecutableJobPortType_GetResourceProperty_fault_t fault_type;
wsrp_GetResourcePropertyResponseType *grpr;
xsd_any *fault;
xsd_QName *qname;
globus_result_t ret;

        ret=ManagedExecutableJobService_client_init(&handle,
                mon->msg_attr,
		NULL);
        if (ret) die("ManagedExecutableJobService_client_init");

	xsd_QName_init(&qname);
	xsd_QName_copy_contents(qname,
		&ManagedExecutableJobPortType_stdoutURL_rp_qname);

        ret=ManagedExecutableJobPortType_GetResourceProperty_epr(handle,
		mon->job_epr,
		qname,
		&grpr,
		&fault_type,
		&fault);
        if (ret) die("MEJPT_GetResourceProperty_epr");

        /* nota bene! strdup the URI, don't just simply reference it! or else ... */
        mon->stdout_url = (xsd_anyURI) strdup(*(char **)(grpr->any.elements[0].value));

        ManagedExecutableJobService_client_destroy(handle);
        wsrp_GetResourcePropertyResponseType_destroy_contents(grpr);
	xsd_QName_destroy(qname);
}

static void start_ftp(monitor_t *mon) {   
globus_ftp_client_handleattr_t      ftp_handleattr;
globus_result_t ret;
    
        globus_ftp_client_handleattr_init(&ftp_handleattr);
        globus_ftp_client_operationattr_init(&mon->ftp_attr);
        globus_ftp_client_operationattr_set_data_protection(&mon->ftp_attr,
                GLOBUS_FTP_CONTROL_PROTECTION_PRIVATE);
        ret=globus_ftp_client_operationattr_set_read_all(&mon->ftp_attr,
                GLOBUS_TRUE, NULL, NULL);
        if (ret) die("globus_ftp_client_operationattr_set_read_all");
        // never! forget the line below. or else ... !
        globus_ftp_client_handleattr_set_cache_all(&ftp_handleattr, GLOBUS_TRUE);
        globus_ftp_client_handle_init(&mon->ftp_handle,&ftp_handleattr);
        globus_ftp_client_handleattr_destroy(&ftp_handleattr);
        ftp_get(mon);
}

static void release_hold(monitor_t *mon) {
wsgram_ReleaseInputType             release;
globus_result_t                     ret;

        wsgram_ReleaseInputType_init_contents(&release);

        wsgram_ReleaseOutputType *releaseResponse;
        ManagedJobPortType_release_fault_t fault_type;
        xsd_any *fault;
        ret=ManagedJobPortType_release_epr(mon->job_handle,
                mon->job_epr,
                &release,
                &releaseResponse,
                &fault_type,
                &fault);
        if (ret) die("MJPT_release_epr_register");

        wsgram_ReleaseInputType_destroy_contents(&release);
}

static void notify_cb(
    void *                              arg,
    wsnt_TopicExpressionType *          topic,
    wsa_EndpointReferenceType *         producer,
    xsd_anyType *                       message)
{
monitor_t *mon = (monitor_t *) arg;

        wsgram_StateChangeNotificationMessageWrapperType * scnmw;
        wsgram_StateChangeNotificationMessageType * scnm;

        scnmw = (wsgram_StateChangeNotificationMessageWrapperType *)
            message->value;
        scnm = &scnmw->stateChangeNotificationMessage;

	if (strcmp(scnm->state,wsgram_StateEnumeration_CleanUp)==0) {
                if (scnm->holding) {
			get_stdout_url(mon);
                        release_hold(mon);  // continue job
			start_ftp(mon);
		}
	}
}

/*
 * make X509_USER_PROXY appear on remote side.
 */

static void delegate(
	ManagedJobFactoryService_client_handle_t    factory_handle,
	monitor_t *mon,
    	wsgram_CreateManagedJobInputType *  input)
{
wsa_EndpointReferenceType *factory_epr;
wsgram_JobDescriptionType *jd;
xsd_QName *qname;

        jd = &input->choice_value.value.job;

        globus_delegation_client_util_handle_t delegation_handle;
        globus_gsi_cred_handle_t            cred_handle;
        globus_gsi_cert_utils_cert_type_t   proxy_type;

        if (globus_gsi_cred_handle_init(&cred_handle,NULL))
        	die("globus_gsi_cred_handle_init");
        if (globus_gsi_cred_read(cred_handle,NULL))
		die("globus_gsi_cred_read");
        if (globus_gsi_cred_get_cert_type(cred_handle,&proxy_type))
		die("globus_gsi_cred_get_cert_type");

        if(GLOBUS_GSI_CERT_UTILS_IS_RFC_PROXY(proxy_type))
                proxy_type=GLOBUS_GSI_CERT_UTILS_TYPE_RFC_LIMITED_PROXY;
        else if(GLOBUS_GSI_CERT_UTILS_IS_GSI_2_PROXY(proxy_type))
                proxy_type=GLOBUS_GSI_CERT_UTILS_TYPE_GSI_2_LIMITED_PROXY;
        else
                proxy_type=GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_LIMITED_PROXY;

        if (globus_delegation_client_util_handle_init(
                &delegation_handle,
                mon->msg_attr,
                NULL,
                cred_handle, NULL))
        	die("globus_gsi_cred_get_cert_type");

        xsd_QName_init(&qname);
        xsd_QName_copy_contents(qname,
                &ManagedJobFactoryPortType_delegationFactoryEndpoint_rp_qname);
        wsrp_GetResourcePropertyResponseType *grpr;
        ManagedJobFactoryPortType_GetResourceProperty_fault_t fault_type;
        xsd_any *fault;
         if (ManagedJobFactoryPortType_GetResourceProperty_epr(
                factory_handle,
                jd->factoryEndpoint,
                qname,
                &grpr,
                &fault_type,
                &fault))
        	die("MJFPT_GetResourceProperty_epr");
        factory_epr=(wsa_EndpointReferenceType *) grpr->any.elements[0].value;

        if (globus_delegation_client_util_delegate_epr(delegation_handle,
                factory_epr,
                proxy_type,
                &jd->jobCredentialEndpoint))
		die("globus_delegation_client_util_delegate_epr");

        wsrp_GetResourcePropertyResponseType_destroy_contents(grpr);
        xsd_QName_destroy(qname);

        globus_delegation_client_util_handle_destroy(delegation_handle);
        globus_gsi_cred_handle_destroy(cred_handle);
}


/*
* web-serviced based version of gssexec
*
*/

int gssexec(char *host,char *exec,u_short port,char *rsl,
	int argc,char *argv[]) {
wsgram_CreateManagedJobInputType input;
wsgram_JobDescriptionType *jd;
globus_service_engine_t engine;
globus_uuid_t submission_id;
char *factory,*factory_type="Fork",*hostname,*cp;
monitor_t mon;
globus_result_t ret;
xsd_any *fault;
char version[32];
char buf[128]={0,};
int i;

        globus_module_activate(GLOBUS_XIO_MODULE);

        globus_module_activate(GLOBUS_GSI_CERT_UTILS_MODULE);
        globus_module_activate(GLOBUS_GSI_CREDENTIAL_MODULE);

        globus_module_activate(GLOBUS_FTP_CLIENT_MODULE);
        globus_module_activate(GLOBUS_SOAP_MESSAGE_MODULE);
        globus_module_activate(GLOBUS_NOTIFICATION_CONSUMER_MODULE);
        globus_module_activate(GLOBUS_DELEGATION_CLIENT_UTIL_MODULE);

        globus_module_activate(MANAGEDJOBSERVICE_MODULE);
        globus_module_activate(MANAGEDJOBFACTORYSERVICE_MODULE);
        globus_module_activate(MANAGEDEXECUTABLEJOBSERVICE_MODULE);
        globus_module_activate(DELEGATIONSERVICE_MODULE);
        globus_module_activate(SUBSCRIPTIONMANAGERSERVICE_MODULE);

	memset(&input,0,sizeof(input));
	memset(&mon,0,sizeof(mon));
	//globus_cond_init(&mon.cond, 0);
	globus_mutex_init(&mon.lock,0);

	// setup message
	globus_soap_message_attr_init(&mon.msg_attr);
	globus_soap_message_attr_set(mon.msg_attr,
		GLOBUS_SOAP_MESSAGE_AUTHZ_METHOD_KEY,
		NULL,NULL,
		(void *)GLOBUS_SOAP_MESSAGE_AUTHZ_HOST);
	globus_soap_message_attr_set(mon.msg_attr,
		GLOBUS_SOAP_MESSAGE_AUTHENTICATION_METHOD_KEY,
		NULL,NULL,
		(void *)GLOBUS_SOAP_MESSAGE_AUTH_SECURE);
	globus_soap_message_attr_set(mon.msg_attr,
		GLOBUS_SOAP_MESSAGE_AUTH_PROTECTION_KEY,
		NULL,NULL,
		(void *)GLOBUS_SOAP_MESSAGE_AUTH_PROTECTION_PRIVACY);

	wsgram_CreateManagedJobInputType_init_contents(&input);
	jd=&input.choice_value.value.job;

	hostname=host;
	if ((cp=index(hostname,'/'))) {
		*cp=0;
		factory_type=cp+1;
	}
	// hostname
	if ((factory=(char *)malloc(strlen(hostname)+strlen(MANAGEDJOBFACTORYSERVICE_BASE_PATH)+16))==NULL)
		die("malloc");
	strcpy(factory,"https://");
	strcat(factory,hostname);
	strcat(factory,":8443/");
	strcat(factory,MANAGEDJOBFACTORYSERVICE_BASE_PATH);

	wsa_EndpointReferenceType       *epr;
	wsa_EndpointReferenceType_init(&epr);
        xsd_anyURI_copy_contents_cstr(&epr->Address.base_value,factory);

	// executable ...
        input.choice_value.type = wsgram_CreateManagedJobInputType_job;

        i=sizeof(buf)-strlen(buf)-1;
        if (do_staging) {       /* stage executable */
		die("gt4 exec staging not supported");
#if 0
                strncat(buf,su,i);
                i=sizeof(buf)-strlen(buf)-1;
                if (!do_exec) {
                        strncat(buf,"/proc/self/exe",i);
                        i=sizeof(buf)-strlen(buf)-1;
                }
#endif
        }
        if (do_exec || (!do_exec && !do_staging)) {     /* -l (location) parameter specified */
                if (exec[0]!='/') { /* relative filename */
                        strncat(buf,"${GLOBUS_LOCATION}",i);
                        i=sizeof(buf)-strlen(buf)-1;
                        strncat(buf,"/",i);
                        i--;
                }
                strncat(buf,exec,i);
        }
        xsd_string_copy_cstr(&jd->executable,buf);

	/* construct "command line" for remote glogin */

        xsd_string *xstr;
	xstr=xsd_string_array_push(&jd->argument);
	xsd_string_copy_contents_cstr(xstr,"-p");
	sprintf(buf,"%d:%s",opt_port,inet_ntoa(self_addr));
	xstr=xsd_string_array_push(&jd->argument);
	xsd_string_copy_contents_cstr(xstr,buf);

        /* we need -r to tell glogin that it executes remotely */
	xstr=xsd_string_array_push(&jd->argument);
	xsd_string_copy_contents_cstr(xstr,"-r");

        for(i=1;i<argc;i++) {
                /* ignore these options */
                if (strcmp(argv[i],"-g")==0)    /* staging: ignore */
                        continue;
                if (strcmp(argv[i],"-q")==0) {  /* queue: ignore */
                        i++;
                        continue;
                }
                if (strcmp(argv[i],"-s")==0) {  /* extra rsl: ignore */
                        i++;
                        continue;
                }
                if (strcmp(argv[i],"-p")==0) {  /* port: ignore (handled above) */
                        i++;
                        continue;
                }
		xstr=xsd_string_array_push(&jd->argument);
		xsd_string_copy_contents_cstr(xstr,argv[i]);
        }

        wsa_ReferencePropertiesType_init(&epr->ReferenceProperties);
        xsd_any *any_entry;
        any_entry=xsd_any_array_push(&epr->ReferenceProperties->any);
        any_entry->any_info=&xsd_string_info;
        xsd_QName_copy(&any_entry->element,&factory_type_ResourceID_qname);
        //xsd_string_copy_cstr((xsd_string **) &any_entry->value,"Fork");
        //xsd_string_copy_cstr(&any_entry->value,"Fork");
        xsd_string_copy_cstr(&any_entry->value,factory_type);
        input.choice_value.value.job.factoryEndpoint=epr;

	// termination time
	time_t tt;
        tt=time(NULL)+60*60*24; // terminate in 24 hours
        xsd_dateTime_copy(&input.InitialTerminationTime,
                gmtime(&tt));

        // hold job when in cleanup state
        wsgram_StateEnumeration_copy(&input.choice_value.value.job.holdState,
                &wsgram_StateEnumeration_CleanUp);

	// unique job id
        globus_uuid_create(&submission_id);
        // remote stdout filename
        char *remote_file;
        remote_file=globus_common_create_string(
                "file:///${GLOBUS_USER_HOME}/%s.stdout", 
                submission_id.text);
        xsd_string_copy_cstr(&jd->Stdout,remote_file+7);

        wsnt_SubscribeType subscribe;
        wsnt_SubscribeType_init_contents(&subscribe);
        xsd_any_init(&subscribe.TopicExpression.any);
        subscribe.TopicExpression.any->any_info = &xsd_QName_contents_info;
        //xsd_QName_copy((xsd_QName *) &subscribe.TopicExpression.any->value,
        xsd_QName_copy(&subscribe.TopicExpression.any->value,
                &ManagedJobPortType_state_rp_qname);
        xsd_anyURI_copy_cstr(&subscribe.TopicExpression._Dialect,
                "http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Simple");
        xsd_boolean_init(&subscribe.UseNotify);
        *subscribe.UseNotify = GLOBUS_TRUE;

        ret=globus_service_engine_init(&engine,
                mon.msg_attr, NULL,
                NULL,
                GLOBUS_TRUE); // use https
        if (ret) die("globus_service_engine_init");

        ret=globus_notification_create_consumer(
                &subscribe.ConsumerReference,
                engine,notify_cb,&mon);
        if (ret) die("globus_notification_create_consumer");

	// create handle for job submission
        ManagedJobFactoryService_client_handle_t factory_handle;
        ManagedJobFactoryService_client_init(&factory_handle,
                mon.msg_attr,NULL);

	delegate(factory_handle,&mon,&input);

        ManagedJobFactoryPortType_createManagedJob_fault_t create_fault_type;
        wsgram_CreateManagedJobOutputType *output;

        // submit the job
        ret=ManagedJobFactoryPortType_createManagedJob_epr(factory_handle,
                input.choice_value.value.job.factoryEndpoint,
                &input,&output,
                &create_fault_type,&fault);
	if (ret) die("MJPT_createManagedJob_epr");
	mon.job_epr=&output->managedJobEndpoint;

	ret=ManagedJobService_client_init(&mon.job_handle,
		mon.msg_attr,
                NULL);
	if (ret) die("MJS_client_init");

        wsnt_SubscribeResponseType *subscribe_response;
        ManagedJobPortType_Subscribe_fault_t subscribe_fault_type;
        ret=ManagedJobPortType_Subscribe_epr(mon.job_handle,
            mon.job_epr,
            &subscribe,
            &subscribe_response,
            &subscribe_fault_type,
            &fault);
        if (ret) die("MJPT_Subscribe_epr");
        wsnt_SubscribeResponseType_destroy(subscribe_response);

        ret=globus_service_engine_register_start(engine,NULL,0);
	if (ret) die("globus_service_engine_register_start");

	do {
		globus_cond_wait(&mon.cond,&mon.lock);
		if (mon.done==-1)
			break;
	} while(1);

        if (mon.rc==28)
                die("incompatible versions");   // length of initseq <= v0.97

        //if (mon.rc!=sizeof(sq))
        //        die("read");
	if (mon.rc-mon.sq.sq_vers_len-1!=sizeof(mon.sq))
		die("read");
        if (mon.sq.sq_vers_len>=sizeof(version))
                die("strange version");
        i=mon.sq.sq_vers_len+1;

        if (strcmp(mon.version,GSH_PROTOCOL))
                die("wrong protocol version");

        opt_port=ntohs(mon.sq.sq_port);
        debug("got port=%d\n",opt_port);

        /* ip addr of other end */
        r_addr=*(struct in_addr *)&mon.sq.sq_inaddr;

        /* endian signature */
        eflag=mon.sq.sq_beef!=0xfeedbeef;

        /* and now the secret key */
        memcpy(g_ic.secret,mon.sq.sq_secret,16);

        globus_module_deactivate(SUBSCRIPTIONMANAGERSERVICE_MODULE);
        globus_module_deactivate(DELEGATIONSERVICE_MODULE);
        globus_module_deactivate(MANAGEDEXECUTABLEJOBSERVICE_MODULE);
        globus_module_deactivate(MANAGEDJOBFACTORYSERVICE_MODULE);
        globus_module_deactivate(MANAGEDJOBSERVICE_MODULE);

        globus_module_deactivate(GLOBUS_DELEGATION_CLIENT_UTIL_MODULE);
        globus_module_deactivate(GLOBUS_NOTIFICATION_CONSUMER_MODULE);
        globus_module_deactivate(GLOBUS_SOAP_MESSAGE_MODULE);
        globus_module_deactivate(GLOBUS_FTP_CLIENT_MODULE);

        globus_module_deactivate(GLOBUS_GSI_CREDENTIAL_MODULE);
        globus_module_deactivate(GLOBUS_GSI_CERT_UTILS_MODULE);

        globus_module_deactivate(GLOBUS_XIO_MODULE);

	return 0;
}
#endif
