
#include	<stdio.h>
#include	<stdarg.h>
#include	<sys/types.h>
#include	<string.h>
#include	<strings.h>
#include	<syslog.h>

#include	"glogin.h"

extern int do_remote;
extern char *self;

#ifdef DEBUG
static void _syslog(int prty,char *buf) {
static FILE *fp;
static pid_t mypid;

        if (fp==NULL) {
	int fd;
                //if ((fd=open("/tmp/syslog",O_TRUNC|O_CREAT|O_WRONLY,0660))==-1)
                if ((fd=open("/tmp/syslog",O_APPEND|O_CREAT|O_WRONLY,0660))==-1) {
                //if ((fd=open("/home/gup/hr/syslog",O_APPEND|O_CREAT|O_WRONLY,0660))==-1)
                        // exit(-1);
			fprintf(stderr,"failed to open syslog");
                       	fp=fopen("/dev/null","a");
                       	return;
		}
                dup2(fd,254);
                close(fd);
		if ((fp=fdopen(254,"a"))==NULL)
			exit(-1);
		mypid=getpid();
        }
	fprintf(fp,"syslog: %5d %s [%s]\n",
		(int)mypid,
		do_remote?"remote":"glogin",
		buf);
	fflush(fp);
}
#else
#define	_syslog syslog
#endif


static void _logger(int opt,int fac,int level,char *buf) {
char *cp,*cp2;

#ifndef DEBUG
	openlog(do_remote?"remote":self,opt,fac);
#endif

	// if (!do_remote)
	// 	fprintf(stderr,buf);

	cp=buf;
	for(;;) {
		cp2=index(cp,'\n');
		if (cp2) *cp2=0;
		_syslog(fac|level,cp);
		if (cp2==NULL) break;
		cp=cp2+1;
		if (*cp==0) break;
	}

#ifndef DEBUG
	closelog();
#endif
}

/* gah ... allthough it is possible (I've read) to use the ellipse
 * with gcc-3, it is not with gcc-2.95. therefore, we cannot just
 * #define logger(fmt,...) _logger(whatever,fmt,...)
 */

/*
 * WOAH THERE!
 *
 * gcc produces +2kb more code if one writes:
 *
 * inline void debug(char *fmt,...) {}
 *
 * instead of #define debug(fmt,...)
 *
 * that's strange!
 *
 */

#ifdef DEBUG
void debug(char *fmt,...) {
static int in_debug=0;
//char buf[4096];
char buf[256];
va_list ap;

	if (in_debug)
		return;
	in_debug=1;
	va_start(ap,fmt);
	vsnprintf(buf,sizeof(buf),fmt,ap);
	va_end(ap);
	_logger(LOG_PID,LOG_DAEMON,LOG_DEBUG,buf);
	in_debug=0;
}
#endif

void logger(int level,char *fmt,...) {
char buf[1024];
va_list ap;
	va_start(ap,fmt);
	vsnprintf(buf,sizeof(buf),fmt,ap);
	va_end(ap);
	_logger(LOG_PID,LOG_DAEMON,level,buf);
}

// would like to write like this, but gcc2.95 wont let me
// probably related to C89 vs. C99
// void debug(char *fmt,...) {
// 	logger(LOG_DEBUG,fmt,...);
// }


