/*
 * Tue Oct 28 13:57:03 CET 2003 herp - Herbert Rosmanith
 *
 * token.c - helper functions for sending data over gss-connections
 */


#include	<stdlib.h>
#include	<sys/types.h>
#include	<syslog.h>
#include	<unistd.h>

#include	"glogin.h"
#include	"channel.h"

#if 0
int save_read(int fd,void *arg,int len) {
char *buf=(char *)arg;
int i,n;

	//logger(LOG_INFO,"> save_read fd=%d len=%d\n",fd,len);
	//debug("> save_read len=%d\n",len);
	n=len;
	for(;;) {
		for(;;) {
			/* SA_RESTART ?! */
			if ((i=read(fd,buf,len))==-1) {
				if (errno!=EINTR)
					break;
				fprintf(stderr,"save_read: only got %d bytes on fd%d: %d %s\n",
					i,fd,errno,strerror(errno));
				return -1;
			}
			break;
		}
		if ((len-=i)==0)
			break;
		buf+=i;
	}
	//logger(LOG_INFO,"  save_read returning %d bytes\n",n);
	//debug("< save_read");
	return n;
}
#endif

int save_read(int fd,void *arg,int len) {
char *buf=(char *)arg;
int i,n;

        n=len;
        for(;;) {
                i=read(fd,buf,n);
                if (i==0)
                        die("eof");
                if (i==-1)
                        die("read");
                n-=i;
                if (n==0)
                        break;
                buf+=i;
        }
        return len;
}

int read_token_unbuffered(int fd,void *token,uint32_t len) {
static uint32_t n=0;
char *cp=(char *)token;
int i,j,rc=0;

        // logger(LOG_AUTH,"> %s\n",__FUNCTION__);
        if (len<5) {
                debug("len1\n");
                logger(LOG_AUTH,"len1\n");
                return -1;
        }
        /* read the begin of a token from fd */
        if (n==0) {
                rc=5;
                if (read(fd,token,5)!=5) {
                        debug("read1\n");
                        logger(LOG_AUTH,"read1\n");
                        return -1;
                }
                n=0;
                memcpy(((u_char *)&n)+2,token+3,2);
                n=ntohl(n);
                cp=token+5;
                len-=5;
        }
        j=len<n?len:n;
        if ((i=save_read(fd,cp,j))!=j) {
                debug("buffer read2: want=%d got=%d\n",n,i);
                logger(LOG_AUTH,"buffer read2: want=%d got=%d\n",j,i);
                return -1;
        }
        n-=i;
        rc+=i;
        // logger(LOG_AUTH,"return n+5=%d\n",rc);
        return rc;
}

/*
 * warning: this function allocates the space needed to store
 * the token. the caller is responsible for freeing it.
 *
 * Wed Oct 12 00:54:52 CEST 2005 herp: not anymore. instead,
 * the return pointer is set to a static data area.
 */

#if 0
static int max_len=0;
#endif

// 4 = fuer die laenge
// 5 + 0x20 = encryption header
// GSH_BUF_SIZE = daten.

//#define	_TOKEN_SIZE	(4*(4096+5+32))
//#define	_TOKEN_SIZE	(4*(32768+5+32))
//#define	_TOKEN_SIZE	(4*(16384+5+32))
//#define	_TOKEN_SIZE	(4*GSH_TOKEN_SIZE)

#define	_STATIC_SIZE	sizeof(static_token)
static u_char static_token[4*GSH_TOKEN_SIZE];
static u_char *tptr=static_token;
static int tlen=0;

int token_buffer_empty=1;

int read_token_enc(int fd,void **token,uint32_t *len,int *data_left) {
uint32_t n;
int i;

	//logger(LOG_INFO,"tpos=%d\n",tptr-static_token);
	debug("> read_token_enc: tpos=%d tlen=%d\n",
		tptr-static_token,tlen);
//	fprintf(stderr,"> read_token_enc: tpos=%d tlen=%d\n",
//		tptr-static_token,tlen);
	while(tlen<5) {
		// an den anfang damit
		//if (tlen && tptr+tlen>=static_token+_STATIC_SIZE) {
		if (tlen && tptr!=static_token) {
			debug("copying(1)....\n");
//			fprintf(stderr,"copying(1)....\n");
			memcpy(static_token,tptr,tlen);
		}
		debug("read(%d,static_token+%d,%d)\n",
			fd,tlen,_STATIC_SIZE);
//		fprintf(stderr,"read(%d,static_token+%d,%d)\n",
//			fd,tlen,_STATIC_SIZE);
		// if ((i=read(fd,static_token+tlen,_STATIC_SIZE))<1) {
		i=read(fd,static_token+tlen,_STATIC_SIZE-tlen);
		debug("  read got %d bytes\n",i);
//		fprintf(stderr,"%s: tlen=%d, got %d bytes\n",__FUNCTION__,tlen,i);
		if (i<1) {
#ifdef DEBUG
			if (i==-1)
				debug("got -1 bytes, errno=%d %s\n",
					errno,strerror(errno));
			if (i==0)
				debug("got 0 bytes\n");
#endif
			die("read");
		}
		//logger(LOG_INFO,"  read1() got %d bytes\n",i);
		debug("  read1() got %d bytes\n",i);
		tptr=static_token;
		tlen+=i;
	}

	// bus error on sun:
	// n=ntohs(*(uint16_t *)&tptr[3]);

	n=0;
	memcpy(((u_char *)&n)+2,tptr+3,2);
	n=ntohl(n);
	if (n>GSH_TOKEN_SIZE) {
		//abort();
		die("token size overflow");
	}

	debug("  read_token: n=%d tlen=%d delta=%d\n",n,tlen,tlen-n);

	while(tlen-5<n) {
		//logger(LOG_INFO,"  partial read\n");
		debug("  partial read\n");

		// partielles packet.
		// note: kopieren ist nur dann notwendig, wenn
		// das ende des packets ueber das ende des static_token
		// rauszeigt
		//if (tptr+tlen>=static_token+_TOKEN_SIZE) {
		if (tptr+n+5>=static_token+_STATIC_SIZE) {
			// an den anfang damit
			debug("copying(2)....\n");
			//logger(LOG_INFO,"copying(2)...\n");
			if (static_token==tptr)
				die("out of token memory");
			memcpy(static_token,tptr,tlen);
			tptr=static_token;
		}
		//if ((i=read(fd,tptr+tlen,_TOKEN_SIZE))<1)
		if ((i=read(fd,tptr+tlen,n-tlen+5))<1)
			die("read");
		//logger(LOG_INFO,"  read2() got %d bytes\n",i);
		tlen+=i;

		if (tlen-5==n)
			debug("  got exactly one packet\n");
	}


	n+=5;
	*token=tptr;
	*len=n;

	if ((tlen-=n)==0)		/* remaining data */
		tptr=static_token;
	else
		tptr+=n;		/* advance to next token */

	debug("  data left: %d bytes\n",tlen);
//	fprintf(stderr,"  data left: %d bytes\n",tlen);

	if (data_left)
		*data_left=tlen;
	token_buffer_empty=!tlen;
	debug("< read_token\n");
	return n;
}

int read_token_clear(int fd,void **token,uint32_t *len,int *data_left) {
uint32_t n;
int i;

	debug("> read_token_clear\n");

	// /* no data present at all */
	// if (tlen==0) {
	while(tlen<5) {
		// wenns ueber der haelfte ist: an den anfang damit
		if (tlen && tptr+tlen>=static_token+_STATIC_SIZE)
			memcpy(static_token,tptr,tlen);
		if ((i=read(fd,static_token+tlen,_STATIC_SIZE-tlen))<1)
			die("read");
		tptr=static_token;
		tlen+=i;
	}

	// bus error on sun
	// n=*(uint32_t *)tptr;

	n=0;
	memcpy(((u_char *)&n)+2,tptr+3,2);
	n=ntohl(n);

	debug("  read_token: n=%d tlen=%d delta=%d\n",n,tlen,tlen-n);
	debug("  read_token: header=%.2x %.2x %.2x %.2x %.2x\n",
		tptr[0], tptr[1], tptr[2], tptr[3], tptr[4]);
	debug("  read_token: header=%c %c %c %c %c\n",
		tptr[0], tptr[1], tptr[2], tptr[3], tptr[4]);

	//if (tptr[0]!=0xa5 || n>GSH_TOKEN_SIZE)
	if (n>GSH_TOKEN_SIZE)
		die("token size overflow");

	while(tlen-5<n) {
		debug("  partial read\n");

		// partielles packet irgendwo nach der mitte
		// note: kopieren ist nur dann notwendig, wenn
		// das ende des packets ueber das static_token
		// rauszeigt
		//if (tptr+tlen>=static_token+_TOKEN_SIZE) {
		if (tptr+n+5>=static_token+_STATIC_SIZE) {
			// an den anfang damit
			//logger(LOG_INFO,"copying(2)... tlen=%d\n",tlen);
			if (static_token==tptr)
				die("out of token memory");
			memcpy(static_token,tptr,tlen);
			tptr=static_token;
		}
		if ((i=read(fd,tptr+tlen,n-tlen+5))<1)
			die("read");
		tlen+=i;
		if (tlen-5==n)
			debug("  got exactly one packet\n");
	}

	*token=tptr+5;			// skip over header
	*len=n;
	n+=5;

	if ((tlen-=n)==0)		/* remaining data */
		tptr=static_token;
	else
		tptr+=n;		/* advance to next token */

	if (data_left)
		*data_left=tlen;
	token_buffer_empty=!tlen;
	debug("< read_token\n");
	return n;
}

int write_token_enc(int fd,void *token,uint32_t len) {
	debug("> write_token_enc fd=%d len=%d\n",fd,len);
	return write(fd,token,len);
}

int write_token_clear(int fd,void *token,uint32_t len) {
struct iovec iov[2];
//char *cp=(char *)token;
u_char c5[5];
u_short sh;

	debug("> write_token_clear fd=%d len=%d %.8x\n",fd,len,len);

	// XXX - wenn der "upper layer" die daten gleich so
	// reinschreibt, dass vorne 5 byte platz sind, so
	// spart man sich den writev() - ich weiss aber nicht,
	// ob das was bringt (muss der kernel sowieso buffer
	// kopieren oder ist das ein zero-copy?)
#if 0
	debug("  token=%p\n",token);
	i=htonl(len);
	memcpy(cp-4,&i,4);
	debug("  cp=%p\n",cp);
	if (write(fd,cp-5,len+5)!=len+5)
		die("write");
	return len;
#endif

	//xdump(token,len);

	// if (len+5>4*(32768+5))
	//if (len+5>4*(16384+5))
	if (len+5>GSH_TOKEN_SIZE)
		die("write_token: length overrun");
	c5[0]=0xa5;
	c5[1]=0xa5;
	c5[2]=0xa5;
	sh=htons(len);
	memcpy(&c5[3],&sh,2);
	iov[0].iov_base=(void *)&c5;
	iov[0].iov_len=5;
	iov[1].iov_base=token;
	iov[1].iov_len=(signed)len;
	if (writev(fd,iov,2)!=(signed)len+5)
		die("writev");
	//logger(LOG_INFO,"  write_token: returning %d\n",len);
	debug("< write_token\n");
	return len;

}
